#!/usr/bin/env python3
#-*- coding:utf-8 -*-
try:
    import sys
    import importlib
    importlib.reload(sys)
    from gspylib.inspection.common import SharedFuncs
    from gspylib.inspection.common.CheckItem import BaseItem
    from gspylib.inspection.common.CheckResult import ResultStatus
except ImportError as e:
    raise Exception("[GAUSS-52200] : Unable to import module: %s." % str(e))


class CheckPgPreparedXacts(BaseItem):
    def __init__(self):
        super(CheckPgPreparedXacts, self).__init__(self.__class__.__name__)

    def doCheck(self):
        sqlcmd = "SELECT * FROM pg_catalog.pgxc_prepared_xacts;"
        self.result.raw = sqlcmd

        output = SharedFuncs.runSqlCmd(sqlcmd, self.user, "", self.port, self.tmpPath, "postgres", self.mpprcFile)
        if (output != ""):
            self.result.rst = ResultStatus.NG
        else:
            self.result.rst = ResultStatus.OK
        self.result.val = output

    def doSet(self):
        cmd = "gs_clean -s -v -a -p %s -r" % self.port
        output = SharedFuncs.runShellCmd(cmd, self.user, self.mpprcFile)
        self.result.val = output
